/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package util.dao;

import beans.Polaganje;
import beans.Student;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author jelica
 */
public class NastavnikDAO {
    public static Student nadjiStudentaPoIndeksu(String indeks){
        
        Connection conn = util.DB.getInstance().getConnection();
        PreparedStatement ps = null;
        try {
            ps = conn.prepareStatement("select * from"
                    + " korisnici where korime=?");
            
            ps.setString(1, indeks);
            
            ResultSet rs = ps.executeQuery();
            
            if(rs.next()){
                ps = conn.prepareStatement("select ime, prezime, COUNT(*) as broj, "
                        + "AVG(ocena) as prosek "
                        + "from korisnici k, ispiti i where k.korime = i.korime and "
                        + "k.korime = ? and i.ocena>5");
                ps.setString(1, indeks);
                
                ResultSet rs2 = ps.executeQuery();
                
                if(rs2.next()){
                    Student student = new Student();
                    
                    student.setIme(rs2.getString("ime"));
                    student.setPrezime(rs2.getString("prezime"));
                    student.setBrPolozenih(rs2.getInt("broj"));
                    student.setProsek(rs2.getDouble("prosek"));
                    
                    return student;
                }                
                return null;               
            }
            return null;
        } catch (SQLException ex) {
            Logger.getLogger(NastavnikDAO.class.getName()).log(Level.SEVERE, null, ex);
        } finally{
            try {
                ps.close();
            } catch (SQLException ex) {
                Logger.getLogger(NastavnikDAO.class.getName()).log(Level.SEVERE, null, ex);
            }
            util.DB.getInstance().putConnection(conn);
        }
        
        return null;
    }
    
    public static boolean proveraPostojanjaStudentaPoIndeksu(String indeks){        
        Connection conn = util.DB.getInstance().getConnection();
        PreparedStatement ps = null;
        try {
            ps = conn.prepareStatement("select * from"
                    + " korisnici where korime=?");           
            ps.setString(1, indeks);           
            ResultSet rs = ps.executeQuery();            
            if(rs.next()){
                return true;
            }
            return false;
        } catch (SQLException ex) {
            Logger.getLogger(NastavnikDAO.class.getName()).log(Level.SEVERE, null, ex);
        } finally{
            try {
                ps.close();
            } catch (SQLException ex) {
                Logger.getLogger(NastavnikDAO.class.getName()).log(Level.SEVERE, null, ex);
            }
            util.DB.getInstance().putConnection(conn);
        }        
        return false;
    }
    
    public static int unosOcene(Polaganje p){
        Connection conn = util.DB.getInstance().getConnection();
        PreparedStatement ps = null;
        try {
            ps = conn.prepareStatement("select * from ispiti where korime=? and sifraPredmet=? and datum=?");
            ps.setString(1, p.getIndeks());
            ps.setString(2, p.getSifraPredmeta());
            ps.setDate(3, new java.sql.Date(p.getDatum().getTime()));
            
            ResultSet rs = ps.executeQuery();
            
            if(rs.next()){
                //update
                if(rs.getInt("ocena")!=5){
                    //samo ako je ocena razlicita od 5 moze da se menja
                    ps = conn.prepareStatement("update ispiti set ocena=? where korime=? and sifraPredmet=? and datum=?");
                    ps.setInt(1, p.getOcena());
                    ps.setString(2, p.getIndeks());
                    ps.setString(3, p.getSifraPredmeta());
                    ps.setDate(4, new java.sql.Date(p.getDatum().getTime()));
                    
                    ps.executeUpdate();
                    return 1; //1 - update ok
                }
                else{
                    return 2; //2 - ne sme da se menja ocena
                }
            }
            else{
                //insert
                
                ps = conn.prepareStatement("insert "
                    + "into ispiti(korime, sifraPredmet, datum,"
                    + "ocena) values(?,?,?,?)");
            
                ps.setString(1, p.getIndeks());
                ps.setString(2, p.getSifraPredmeta());
                ps.setDate(3, new java.sql.Date(p.getDatum().getTime()));
                ps.setInt(4, p.getOcena());

                ps.executeUpdate();
                
                return 3; //3 - insert ok
            }

        } catch (SQLException ex) {
            Logger.getLogger(NastavnikDAO.class.getName()).log(Level.SEVERE, null, ex);
        }finally{
            try {
                ps.close();
            } catch (SQLException ex) {
                Logger.getLogger(NastavnikDAO.class.getName()).log(Level.SEVERE, null, ex);
            }
            util.DB.getInstance().putConnection(conn);
        }
        return 0;//greska
    }
}
